class HomeController < ApplicationController
  layout 'test' if MagicNumber['test_layout']
  before_filter :authenticate_user!, :only => [
    :index, :show, :profile, :configure, :create_token, :delete_token, :step2, :save_step2, :step3, :save_step3, 
    :comic, :panel, :picture, :panel_picture, :panel_color, :ground_picture, :ground_color
  ]
  before_filter :authenticate_artist, :only => [:picture]
  
  def index
  end
  
  def profile
  end
  
  def configure
  end
  
  def create_token
    respond_to do |format|
      if @user.create_token
        format.html { redirect_to({:action => :configure}, {:notice => 'user token was successfully created.'}) }
      else
        format.html { render action: "auth_token" }
      end
    end
  end
  
  def delete_token
    @user.delete_token
    respond_to do |format|
      format.html { redirect_to :action => :configure}
    end
  end
  
  def step2
  end
  
  def save_step2
    respond_to do |format|
      if @author.step2(params[:author][:name])
        a = if params[:step3].to_i == 1
          :step3
        else
          :index
        end
        format.html { redirect_to({:action => a}, {:notice => 'your name was successfully updated.'}) }
      else
        format.html { render action: "step2" }
      end
    end
  end
  
  def step3
  end
  
  def save_step3
    if @author.artist?
      redirect_to :action => :index
    else
      @artist = Artist.new params[:artist]
      respond_to do |format|
        if @artist.save
          format.html { redirect_to({:action => :index}, {:notice => 'artist was successfully registered.'}) }
        else
          format.html { render action: "step3" }
        end
      end
    end
  end
  
  def comic
    @page = Author.page params[:page]
    @page_size = Author.comic_page_size params[:page_size]
    @comics = Comic.mylist(@author, @page, @page_size)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @comics.to_json(Comic.list_json_opt) }
    end
  end
  
  def panel
    @page = Author.page params[:page]
    @page_size = Author.panel_page_size params[:page_size]
    @panels = Panel.mylist(@author, @page, @page_size)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render text: Panel.list_as_json_text(@panels) }
    end
  end
  
  def panel_picture
    @page = Author.page params[:page]
    @page_size = Author.panel_picture_page_size params[:page_size]
    @panel_pictures = PanelPicture.mylist(@author, @page, @page_size)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @panel_pictures.to_json(PanelPicture.list_json_opt) }
    end
  end
  
  def panel_color
    @page = Author.page params[:page]
    @page_size = Author.panel_page_size params[:page_size]
    @panel_colors = PanelColor.mylist(@author, @page, @page_size)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @panel_colors.to_json(PanelColor.list_json_opt) }
    end
  end
  
  def ground_picture
    @page = Author.page params[:page]
    @page_size = Author.panel_page_size params[:page_size]
    @ground_pictures = GroundPicture.mylist(@author, @page, @page_size)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @ground_pictures.to_json(GroundPicture.list_json_opt) }
    end
  end
  
  def ground_color
    @page = Author.page params[:page]
    @page_size = Author.panel_page_size params[:page_size]
    @ground_colors = GroundColor.mylist(@author, @page, @page_size)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @ground_colors.to_json(GroundColor.list_json_opt) }
    end
  end
  
end
