# -*- encoding: utf-8 -*-
require 'spec_helper'

describe ComicsController do
  # This should return the minimal set of attributes required to create a valid
  # Comic. As you add validations to Comic, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {:title => 'test comic', :width => 100, :height => 50, :visible => 0, :editable => 0}
  end

  describe '一覧表示に於いて' do
    before do
      FactoryGirl.create :admin
      @user = FactoryGirl.create( :user_yas)
        FactoryGirl.create :normal_comic, :author_id => 1
        FactoryGirl.create :visible_comic, :author_id => 1
        Factory:editable_comic, :author_id => 1
        FactoryGirl.create :hidden_comic, :author_id => 1
      sign_in @user
    end
    context '作家権限がないとき' do
      context 'ただし、公開型のときだけは' do
        it 'ステータスコード200 OKを返す' do
          sign_out @user
          Const.run_mode = 0
          get :index
          response.should be_success 
        end
      end
    end
  end
  
  describe '単体表示に於いて' do
    before do
      FactoryGirl.create :admin
      @user = FactoryGirl.create( :user_yas)
      @comic = FactoryGirl.create :normal_comic, :author_id => 1
        FactoryGirl.create :visible_comic, :author_id => 1
        Factory:editable_comic, :author_id => 1
      @hidden = FactoryGirl.create :hidden_comic, :author_id => 1
      sign_in @user
    end
    context '作家権限がないとき' do
      context 'ただし、公開型のときだけは' do
        it 'ステータスコード200 OKを返す' do
          sign_out @user
          get :show, :id => @comic.id
          response.should be_success 
        end
      end
    end
  end


end
